//Sub routines called from loadMap.js to handler remarks elements.

//The number of info remarks for the current page.
var infoNbr;
//The number of error remarks for the current page.
var errorNbr;
//The current node for remark (info or error).
var nodeRemark;

//The current node for general information of the current plot.
var nodePlotGeneralInfo;
//The place where to display remark.
var nodeRemarkToDisplay;

//The number of info remarks for the current plot.
var plotInfoNbr;
//The number of error remarks for the current plot.
var plotErrorNbr;

/* The function display the general information of */
/* of the current plot issued from "infos.xml"     */
function displayGeneralInformation(result) 
{
      
      if (!result.content) 
      {
       alert("no content for general Informations !!! ");
       return;
      }

      var docInfo = parseXML(result.content, document);
      nodeRemark = getChildByTagName(docInfo,"root");

      var plot = "Plot" + plotNumber;
     
      var nodeList = nodeRemark.getChildNodes();
      var info = null;
      for (var i = 0; i<nodeList.length; i++) 
      {
         var child  = nodeList.item(i);
	 
         if (child.nodeName == plot)
	 {
	       info=child;
	       break;
	 }
	  
       }


       if (nodePlotGeneralInfo != null)
       {
	  nodeRemarkToDisplay.removeChild(nodePlotGeneralInfo);

       }
       
       if (info != null)
       {
	   var childText = getChildByTagName(info,"text");
	 
           if (childText != null)
	   {
	     nodePlotGeneralInfo = childText.cloneNode(true);
	     nodeRemarkToDisplay.appendChild(nodePlotGeneralInfo);  
	   }
       }

}

/* The function allows to prevent customer which plots     */
/* has errors and/or informations. The way is to display   */
/* the little circle toggle at the top of the plot number. */
function informPlotsAboutRemarks(result) {

     if (!result.content) 
	return;

     var doc = parseXML(result.content, document);
     var rootDoc = getChildByTagName(doc,"root");
     var infoList = rootDoc.getElementsByTagName("info");
     if (infoList.length>1) 
     {
	 plotInfoNbr += infoList.length-1;
     }
     var errorList = rootDoc.getElementsByTagName("error");
     if (errorList.length>1) plotErrorNbr += errorList.length-1;

}

/* The function allows to prevent customer which pages     */
/* has errors and/or informations. The way is to display   */
/* the little circle toggle at the top of the page number. */
function informPagesAboutRemarks(result) {

     
     for(var j = 1; j < 13; j ++)
       {
         var page = "page" + j;
	 var nodePage = document.getElementById(page);
	 var nodeToggleInfo = getChildById(nodePage,"toggleInfo");
	 nodeToggleInfo.setAttribute("display","none");
         var nodeToggleError = getChildById(nodePage,"toggleError");
         nodeToggleError.setAttribute("display","none");
       }
  
     if (!result.content) 
	return;

     
     var doc = parseXML(result.content, document);
     var rootDoc = getChildByTagName(doc,"root");
     

     var list = rootDoc.getChildNodes();
     var child;
     
     for(var j = 1; j < 13; j ++)
       {
	 
	 var page = "page" + j;
	 for (var i = 0; i<list.length; i++) 
	 {
	     child  = list.item(i);
	    
	     if ( child.nodeName == page)
	       {
		 break;
	       }
	 }
	 
	if (child.nodeName != page) continue;

	var node;
	var infoN=0;
	var errorN=0;
	for (node=child.firstChild; node; node = node.nextSibling) {
	
        if (node.nodeName == "info")
	{
	    infoN += 1;
	}
	else if (node.nodeName == "error")
	{
	    errorN += 1;
        }
	
	var nodePage = document.getElementById(page);
	var nodeToggleInfo = getChildById(nodePage,"toggleInfo");
	if (infoN > 0)
	  nodeToggleInfo.setAttribute("display","inline");
	 

	var nodeToggleError = getChildById(nodePage,"toggleError");
        if (errorN > 0)
	  nodeToggleError.setAttribute("display","inline");

	}

       }
}



/*This method draw circles on the map concerned by remarks*/
/*declared in the "Remarks.xml" of the current plot.      */
function drawCircleRemarks(result) {

     
     

     var mapInfo = svgMap.getElementById("infoMap");
     removeChilds(mapInfo);
     mapInfo.setAttribute("display","inline");
     var errorInfo = svgMap.getElementById("errorMap");
     removeChilds(errorInfo);
     errorInfo.setAttribute("display","inline");
     infoNbr = 0;
     errorNbr = 0;


     if (result.content) 
     {

     

     var doc = parseXML(result.content, document);
     var rootDoc = getChildByTagName(doc,"root");
     
     var list = rootDoc.getChildNodes();
     var child;

     //Add Info/Errors on the current page
     var page = "page" + pageNumber;
     for (var i = 0; i<list.length; i++) 
     {
       var child  = list.item(i);
       if ( child.nodeName == page)
       {
	 break;
       }
     }

     if (child.nodeName != page) return;

     nodePlotRemarks = child;

     var node = nodePlotRemarks;
     var indexInfo = 1;
     var indexError= 1;
     for (node=nodePlotRemarks.firstChild; node; node = node.nextSibling) {
	
        if (node.nodeName == "info")
	{
	    addRemark(indexInfo , node);
	    indexInfo = indexInfo + 1;
	    infoNbr += 1;
	}
	else if (node.nodeName == "error")
	{
	    addRemark(indexError , node);
	    indexError = indexError + 1;
	    errorNbr += 1;

       }
     }

       }

     var node = document.getElementById("infoNumber");
     removeChilds(node);
     node.appendChild(document.createTextNode(" " + infoNbr + " information(s) on this page"));
     node = document.getElementById("errorNumber");
     removeChilds(node);
     node.appendChild(document.createTextNode(" " + errorNbr + " major error(s) signaled on this page"));

     var circle = document.getElementById("infoModel");
     if (infoNbr==0)
       circle.setAttribute("class","info");
     else
       circle.setAttribute("class","infoSelected");
     
     circle = document.getElementById("errorModel");
     if (errorNbr==0)
       circle.setAttribute("class","error");
     else
       circle.setAttribute("class","errorSelected");

     nodeSelect=null;
     
}


/*This method draw a circle */
function addRemark(index,node)
{

  var type = node.nodeName;
  var circle = document.createElement("circle");
  circle.setAttribute("class",type + "");
  var mapCircle;
  if (type == "info")
    {
      circle.addEventListener("mouseover",displayInfo,false);
      circle.addEventListener("mouseout",undisplayInfo,false);
      circle.addEventListener("click",setInfo,false);
      mapCircle = svgMap.getElementById("infoMap");
    }
  else
    {
      circle.addEventListener("mouseover",displayError,false);
      circle.addEventListener("mouseout",undisplayError,false);
      circle.addEventListener("click",setError,false);
      mapCircle = svgMap.getElementById("errorMap");
    }

  
  circle.setAttribute("cx",node.getAttribute("x"));
  circle.setAttribute("cy",node.getAttribute("y"));
  circle.setAttribute("r","20");
  circle.setAttribute("id",index);
 
  mapCircle.appendChild(circle);
 
}

/*This function shows information related to the circle */
/*overed by the mouse                                  */ 
function displayInfo(evt)
{
  displayRemark(evt,"info")
}

/*This function fixes information related to the circle */
/*clicked by the mouse                                  */ 
function setInfo(evt)
{
  setRemark(evt,"info")
}

/*This function fixes information related to the circle */
/*clicked by the mouse                                  */ 
function setError(evt)
{
  setRemark(evt,"error")
}

/*This function shows error related to the circle      */
/*overed by the mouse                                  */ 
function displayError(evt)
{
  displayRemark(evt,"error")
}

/*This function removes information related to the circle */
/*overed by the mouse                                     */ 
function undisplayInfo(evt)
{
  undisplayRemark(evt,"info")
}

/*This function removes errors related to the circle      */
/*overed by the mouse                                     */ 
function undisplayError(evt)
{
  undisplayRemark(evt,"error")
}

/*The common function to display an information or an error*/
function displayRemark(evt,type)
{

  if (nodeSelect != null)
    return;

  var obj = evt.target;
  if (obj != null) 
  {
      nodePlotGeneralInfo.setAttribute("display","none");
      var indexToFind = obj.getAttribute("id");
      var index = 1;
      
      var node = nodePlotRemarks;
      if (indexToFind == 0)
      {
	node = nodeRemark;
	//L'index for models are 0;
	index=0;
      }
      else
	obj.setAttribute("class",type + "Selected");
      

      

      
      var nodeList = node.getChildNodes();
      var remark = null;
       for (var i = 0; i<nodeList.length; i++) 
       {
         var child  = nodeList.item(i);
	 
         if (child.nodeName == type)
	 {
	   if (index == indexToFind)
	     {
	       remark=child;
	       break;
	     }
	   else index = index + 1;
	 }
       }

       if (remark != null)
       {
	   var child = getChildByTagName(remark,"g");
	   if (child == null)
	     child = getChildByTagName(remark,"text");
	 
           if (child != null)
	   {
	     
	     var node = child.cloneNode(true);
	     node.setAttribute("class",type);
	     nodeRemarkToDisplay.appendChild(node);
	   }
       }
  }

}

/*The common function to display an information or an error*/
function setRemark(evt,type)
{
  var obj = evt.target;
  if (nodeSelect == null)
  {
     
      nodeSelect = nodeRemark;
      obj.setAttribute("class",type + "Setted");
  }
  else
  {
    nodeSelect = null;
    obj.setAttribute("class",type + "Selected");
  }
   

}

/*The common function to remove an information or an error*/
function undisplayRemark(evt,type)
{

  if (nodeSelect == null)
  {
     
	  var nodeFils = nodeRemarkToDisplay.getLastChild();
	  if (nodeFils!=null) nodeRemarkToDisplay.removeChild(nodeFils);
  
	if (evt != null)
	{
	  var obj = evt.target;
	  if (obj != null) 
	    {
	      var indexToFind = obj.getAttribute("id");
	      if (indexToFind != 0)
		obj.setAttribute("class",type);
	    }
	}

      if (nodePlotGeneralInfo != null)
      nodePlotGeneralInfo.setAttribute("display","inline");
  }
  
}



/*This function informs about the number of informations */
/*concerned by the current page.                         */ 
function showInfo(evt)
{
  
  if (infoNbr>0)
  {
      var circle = document.getElementById("infoModel");
      var select = circle.getAttribute("class");
      var map = svgMap.getElementById("infoMap");
      if (select == "infoSelected")
      {
	circle.setAttribute("class","info");
	map.setAttribute("display","none");
      }
      else
	{
	  circle.setAttribute("class","infoSelected");
	  map.setAttribute("display","yes");
	}
      
  }

}

/*This function informs about the number of errors       */
/*concerned by the current page.                         */ 
function showError(evt)
{
  
  if (errorNbr>0)
  {
      var circle = document.getElementById("errorModel");
      var select = circle.getAttribute("class");
      var map = svgMap.getElementById("errorMap");
      if (select == "errorSelected")
      {
	circle.setAttribute("class","error");
	map.setAttribute("display","none");
      }
      else
	{
	  circle.setAttribute("class","errorSelected");
	  map.setAttribute("display","yes");
	}
      
  }

}

